﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.3
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	
End Sub


'Returns a map of connected devices
Public Sub GetAll As Map
	Dim M As Map = CreateMap()
	Dim Jo As JavaObject
	Jo.InitializeNewInstance(GetClass & ".FriendlyName",Null)
	Dim HashMap As JavaObject = Jo.RunMethodJO("getAll",Null)
	Dim KeySet As JavaObject =  HashMap.RunMethod("keySet",Null)

	If Not(KeySet.RunMethod("isEmpty",Null)) Then
		Dim It As JavaObject = KeySet.RunMethod("iterator",Null)
		Do While It.RunMethod("hasNext",Null)
			Dim Key As String = It.RunMethod("next",Null)
			M.put(Key,HashMap.RunMethod("get",Array(Key)))
		Loop
	End If
	
	Return M
End Sub


'Only really useful to tell if a device is registered in Windows and has a friendly name (not all connected devices appear to be registered)
Public Sub Get(Port As String) As String
	
	Dim Jo As JavaObject
	Jo.InitializeNewInstance(GetClass & ".FriendlyName",Null)
	Return Jo.RunMethod("getCOM",Array(Port))
End Sub

Private Sub GetClass As String
	Dim Class As String = Me
	Return Class.SubString("class ".Length)
End Sub

'Code from : https://stackoverflow.com/questions/30883825/find-the-friendlyname-of-a-com-port-given-its-comx-name-under-windows-in-java

#If Java
import static com.sun.jna.platform.win32.WinReg.HKEY_LOCAL_MACHINE;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.sun.jna.platform.win32.Advapi32Util;
import com.sun.jna.platform.win32.Win32Exception;

public static class FriendlyName {

    private static final String ENUM = "SYSTEM\\CurrentControlSet\\Enum\\USB";
    private Map<String, String> friendlyNames;
    private static final String KEY = "HARDWARE\\DEVICEMAP\\SERIALCOMM";

    public FriendlyName() {
        friendlyNames = new HashMap<>();

        Pattern p = Pattern.compile(".*?\\(([^)]+)\\)");
        for (String dev : Advapi32Util.registryGetKeys(HKEY_LOCAL_MACHINE, ENUM)) {
            String sb = ENUM + "\\" + dev;
            for (String itm : Advapi32Util.registryGetKeys(HKEY_LOCAL_MACHINE, sb)) {
                String si = sb + "\\" + itm;
                String fn = null;
                try {
                    fn = Advapi32Util.registryGetStringValue(HKEY_LOCAL_MACHINE, si, "FriendlyName");
                } catch (Win32Exception e) {}
                if (fn != null) {
                    Matcher m = p.matcher(fn);
                    if (m.matches()) {
                        friendlyNames.put(m.group(1), fn);
                    }
                }
            }
        }
    }
	
	public Map getAll() {
		return friendlyNames;
	}

    String get(String key) {
        return friendlyNames.get(key);
    }

    public String getCOM(String name) {
        try {
            for (Entry<String, Object> sub : Advapi32Util.registryGetValues(HKEY_LOCAL_MACHINE, KEY).entrySet()) {
                String n = (String) sub.getValue();
                String fn = get(n);
                if (fn != null && fn.startsWith(name))
                    return n;
            }
        } catch (IllegalArgumentException e) {
            System.err.println(e);
        }
        return null;
    }

}
#End If